diff -x asm -Naur linux-2.4.30-orig/drivers/net/au1000_eth.c linux-2.4.30/drivers/net/au1000_eth.c
--- linux-2.4.30-orig/drivers/net/au1000_eth.c	2005-05-12 17:57:26.000000000 +0200
+++ linux-2.4.30/drivers/net/au1000_eth.c	2006-12-11 18:18:37.000000000 +0100
@@ -58,6 +58,7 @@
 #include <asm/cpu.h>
 #include "au1000_eth.h"
 
+#define I3_PATCH
 
 #ifdef AU1000_ETH_DEBUG
 static int au1000_debug = 5;
@@ -97,6 +98,7 @@
 extern inline void str2eaddr(unsigned char *ea, unsigned char *str);
 extern inline unsigned char str2hexnum(unsigned char c);
 extern char * __init prom_getcmdline(void);
+extern char *prom_getenv(char *envname);
 
 /*
  * Theory of operation
@@ -139,12 +141,14 @@
  * code.
  */
 
+#if 0
 static char *phy_link[] = 
 	{"unknown", 
 	"10Base2", "10BaseT", 
 	"AUI",
 	"100BaseT", "100BaseTX", "100BaseFX"
 	};
+#endif
 
 int bcm_5201_init(struct net_device *dev, int phy_addr)
 {
@@ -595,6 +599,93 @@
 	return 0;
 }
 
+int ks8721_init(struct net_device *dev, int phy_addr)
+{
+//	s16 data;
+	
+	printk("ks8721m_init - phy = %d\n", phy_addr);
+
+#if 0
+	/* Stop auto-negotiation */
+	data = mdio_read(dev, phy_addr, MII_CONTROL);
+	mdio_write(dev, phy_addr, MII_CONTROL, data & ~MII_CNTL_AUTO);
+
+	/* Set advertisement to 10/100 and Half/Full duplex
+	 * (full capabilities) */
+	data = mdio_read(dev, phy_addr, MII_ANADV);
+	data |= MII_NWAY_TX | MII_NWAY_TX_FDX | MII_NWAY_T_FDX | MII_NWAY_T;
+	mdio_write(dev, phy_addr, MII_ANADV, data);
+	
+	/* Restart auto-negotiation */
+	data = mdio_read(dev, phy_addr, MII_CONTROL);
+	data |= MII_CNTL_RST_AUTO | MII_CNTL_AUTO;
+	mdio_write(dev, phy_addr, MII_CONTROL, data);
+#endif
+
+	if (au1000_debug > 4)
+	    dump_mii(dev, phy_addr);
+
+	return 0;
+}
+
+int ks8721_reset(struct net_device *dev, int phy_addr)
+{
+	s16 mii_control, timeout;
+	
+	printk("ks8995m_reset\n");
+	mii_control = mdio_read(dev, phy_addr, MII_CONTROL);
+	mdio_write(dev, phy_addr, MII_CONTROL, mii_control | MII_CNTL_RESET);
+	mdelay(1);
+	for (timeout = 100; timeout > 0; --timeout) {
+		mii_control = mdio_read(dev, phy_addr, MII_CONTROL);
+		if ((mii_control & MII_CNTL_RESET) == 0)
+			break;
+		mdelay(1);
+	}
+	if (mii_control & MII_CNTL_RESET) {
+		printk(KERN_ERR "%s PHY reset timeout !\n", dev->name);
+		return -1;
+	}
+	return 0;
+}
+
+int ks8721_status(struct net_device *dev, int phy_addr, u16 *link, u16 *speed)
+{
+	u16 mii_data;
+	struct au1000_private *aup;
+
+	if (!dev) {
+		printk(KERN_ERR "ks8995m_status error: NULL dev\n");
+		return -1;
+	}
+	aup = (struct au1000_private *) dev->priv;
+
+	mii_data = mdio_read(dev, aup->phy_addr, MII_STATUS);
+	if (mii_data & MII_STAT_LINK) {
+		*link = 1;
+		mii_data = mdio_read(dev, aup->phy_addr, MII_PHY_CNTRL);
+		switch((mii_data >> 2) & 0x7) {
+		case 6: /* 100 Full Duplex */
+		    *speed = IF_PORT_100BASEFX;
+		    dev->if_port = IF_PORT_100BASEFX;
+		    break;
+		case 2: /* 100 Half Duplex */
+		    *speed = IF_PORT_100BASETX;
+		    dev->if_port = IF_PORT_100BASETX;
+		    break;
+		default:
+		    *speed = IF_PORT_10BASET;
+		    dev->if_port = IF_PORT_10BASET;
+		}
+	}
+	else {
+		*link = 0;
+		*speed = 0;
+		dev->if_port = IF_PORT_UNKNOWN;
+	}
+	return 0;
+}
+
 #ifdef CONFIG_MIPS_BOSPORUS
 int stub_init(struct net_device *dev, int phy_addr)
 {
@@ -656,6 +747,12 @@
 	ks8995m_status,
 };
 
+struct phy_ops ks8721_ops = {
+	ks8721_init,
+	ks8721_reset,
+	ks8721_status,
+};
+
 #ifdef CONFIG_MIPS_BOSPORUS
 struct phy_ops stub_ops = {
 	stub_init,
@@ -679,6 +776,7 @@
 	{"LSI 80227 10/100 BaseT PHY",0x0016,0xf840, &lsi_80227_ops,0},
 	{"Intel LXT971A Dual Speed PHY",0x0013,0x78e2, &lxt971a_ops,0},
 	{"Kendin KS8995M 10/100 BaseT PHY",0x0022,0x1450, &ks8995m_ops,0},
+	{"Micrel KS8721b/BT 10/100 Base Tx/Fx PHY",0x0022,0x1619, &ks8721_ops,0},
 #ifdef CONFIG_MIPS_BOSPORUS
 	{"Stub", 0x1234, 0x5678, &stub_ops },
 #endif
@@ -1163,7 +1261,8 @@
 	struct au1000_private *aup = NULL;
 	struct net_device *dev = NULL;
 	db_dest_t *pDB, *pDBfree;
-	char *pmac, *argptr;
+	//	char *pmac;
+	char *argptr;
 	char ethaddr[6];
 	int i, err;
 
@@ -1209,6 +1308,17 @@
 		if (!get_ethernet_addr(ethaddr)) { 
 			memcpy(au1000_mac_addr, ethaddr, sizeof(dev->dev_addr));
 		} else {
+#ifdef CONFIG_MIPS_I3_MMB3
+                        argptr = prom_getenv("ethaddr");
+			if(!argptr) {
+				printk(KERN_INFO "%s: No mac address found\n", 
+						dev->name);
+			} else {
+				str2eaddr(ethaddr, argptr);
+				memcpy(au1000_mac_addr, ethaddr, 
+						sizeof(dev->dev_addr));
+			}
+#else
 			/* Check command line */
 			argptr = prom_getcmdline();
 			if ((pmac = strstr(argptr, "ethaddr=")) == NULL) {
@@ -1220,6 +1330,7 @@
 				memcpy(au1000_mac_addr, ethaddr, 
 						sizeof(dev->dev_addr));
 			}
+#endif
 		}
 			aup->enable = (volatile u32 *) 
 				((unsigned long)iflist[0].macen_addr);
@@ -1387,6 +1498,7 @@
 #endif
 	if (link && (dev->if_port == IF_PORT_100BASEFX)) {
 		control |= MAC_FULL_DUPLEX;
+		control &= ~MAC_DISABLE_RX_OWN; /* Added by I3 */
 	}
 	aup->mac->control = control;
 	aup->mac->vlan1_tag = 0x8100; /* activate vlan support */
@@ -1469,7 +1581,12 @@
 	}
 	netif_start_queue(dev);
 
-	if ((retval = request_irq(dev->irq, &au1000_interrupt, 0, 
+#ifdef I3_PATCH
+        // Request fast non-nested interrupt. // AndreasN
+	if ((retval = request_irq(dev->irq, &au1000_interrupt, SA_INTERRUPT,
+#else
+	if ((retval = request_irq(dev->irq, &au1000_interrupt, 0,
+#endif
 					dev->name, dev))) {
 		printk(KERN_ERR "%s: unable to get IRQ %d\n", 
 				dev->name, dev->irq);
diff -x asm -Naur linux-2.4.30-orig/drivers/net/au1000_eth.h linux-2.4.30/drivers/net/au1000_eth.h
--- linux-2.4.30-orig/drivers/net/au1000_eth.h	2005-05-12 17:57:26.000000000 +0200
+++ linux-2.4.30/drivers/net/au1000_eth.h	2006-12-11 18:18:37.000000000 +0100
@@ -140,6 +140,9 @@
 #define MII_AUX_F100     0x0004
 #define MII_AUX_ANEG     0x0008
 
+/* Micrel KS8721B/BT */
+#define MII_PHY_CNTRL 0x001f
+
 typedef struct mii_phy {
 	struct mii_phy * next;
 	struct mii_chip_info * chip_info;
diff -x asm -Naur linux-2.4.30-orig/drivers/sound/au1550_psc.c linux-2.4.30/drivers/sound/au1550_psc.c
--- linux-2.4.30-orig/drivers/sound/au1550_psc.c	2005-05-12 17:57:32.000000000 +0200
+++ linux-2.4.30/drivers/sound/au1550_psc.c	2006-12-11 18:18:37.000000000 +0100
@@ -56,6 +56,8 @@
 #include <asm/au1xxx_psc.h>
 #include <asm/au1xxx_dbdma.h>
 
+#define I3_PATCH
+
 #ifdef CONFIG_MIPS_PB1550
 #include <asm/pb1550.h>
 #endif
@@ -72,6 +74,10 @@
 #include <asm/db1200.h>
 #endif
 
+#ifdef CONFIG_MIPS_I3_MMB3
+#include <asm/mood300.h>
+#endif
+
 #undef OSS_DOCUMENTED_MIXER_SEMANTICS
 
 #define AU1550_MODULE_NAME "Au1550 psc audio"
@@ -88,6 +94,12 @@
  */
 #define NUM_DBDMA_DESCRIPTORS 4
 
+#ifdef I3_PATCH
+//#define DMA_RXTX_LOOP_TRANSFER_SIZE 48*1024+1  // i3 patch
+/* Bug fix for click sound on SPDIF PCM */
+#define DMA_RXTX_LOOP_TRANSFER_SIZE 48*1024
+#endif
+
 #define err(format, arg...) printk(KERN_ERR PFX ": " format "\n" , ## arg)
 #define info(format, arg...) printk(KERN_INFO PFX ": " format "\n" , ## arg)
 
@@ -98,6 +110,10 @@
 MODULE_PARM(vra, "i");
 MODULE_PARM_DESC(vra, "if 1 use VRA if codec supports it");
 
+#ifdef I3_PATCH
+typedef enum {SPDIF_PCM, SPDIF_AC3} spdif_config_t;
+#endif
+
 static struct au1550_state {
 	/* soundcore stuff */
 	int             dev_audio;
@@ -119,7 +135,12 @@
 	mode_t          open_mode;
 	wait_queue_head_t open_wait;
 
+        int             output_disabled;     // for triggers
+
 	struct dmabuf {
+#ifdef I3_PATCH
+                int		allocated;   // ddma channels allocated
+#endif
 		u32		dmanr;
 		unsigned        sample_rate;
 		unsigned	src_factor;
@@ -472,6 +493,114 @@
 	adc->sample_rate = adc_rate;
 }
 
+#ifdef I3_PATCH
+// i3 patch
+static void disable_SPDIF(struct ac97_codec *codec)
+{
+  u32 val;
+
+  val = rdcodec(codec, AC97_EXTENDED_STATUS);
+  val &= ~AC97_EA_SPDIF;
+  wrcodec(codec, AC97_EXTENDED_STATUS, val);
+}
+
+// i3 patch
+static void enable_SPDIF(struct ac97_codec *codec)
+{
+  u32 val;
+
+  val = rdcodec(codec, AC97_EXTENDED_STATUS);
+  val |= AC97_EA_SPDIF;
+  wrcodec(codec, AC97_EXTENDED_STATUS, val);
+}
+
+
+// i3 patch
+static void stop_dac(struct au1550_state *s);
+static void stop_adc(struct au1550_state *s);
+static void set_xmit_slots(int num_channels);
+static void setup_spdif(struct au1550_state *s, spdif_config_t sc)
+{        
+	struct ac97_codec *codec = s->codec;
+        u16 val;
+
+        stop_dac(s);
+        stop_adc(s);
+
+        // Disable spdif before fiddling the registers
+	disable_SPDIF(s->codec);
+
+        //
+        // AC97  Extended Status register
+        //
+        val = rdcodec(codec, AC97_EXTENDED_STATUS);
+
+        // Set which ac-link timeslots that goes out on spdif
+        val &= AC97_EA_SLOT_MASK;
+	if (sc == SPDIF_AC3)
+	  val |= AC97_EA_SPSA_7_8;
+	else
+	  val |= AC97_EA_SPSA_3_4;
+
+        wrcodec(codec, AC97_EXTENDED_STATUS, val);
+
+        
+        //
+        // AC97 SPDIF Control register
+        //
+        val = rdcodec(codec, AC97_SPDIF_CONTROL);
+
+        // This is real strange, if the flag AC97_SC_NAUDIO
+        // is set as below, then the AC97 codec must be reseted
+        // to make the flag unset. The decoder from Creative that
+        // we are using seems to be doing fine without the flag so
+        // we skip it.
+
+        // 48 kHz samplerate
+        val &= AC97_SC_SPSR_MASK;
+        val |= AC97_SC_SPSR_48K;
+
+        wrcodec(codec, AC97_SPDIF_CONTROL, val);
+
+        // Done configuring - enable spdif
+	enable_SPDIF(s->codec);
+
+        // Set AC97 xmit slots. Will also sync ac97 and spdif slots.
+        if (sc == SPDIF_PCM) {
+                // Use link slot 3&4
+                set_xmit_slots(1);
+        } else {
+                // Use link slot 7&8
+                
+                u32	ac97_config, stat;                
+
+                ac97_config = au_readl(PSC_AC97CFG);
+                au_sync();
+                ac97_config &= ~(PSC_AC97CFG_TXSLOT_MASK | PSC_AC97CFG_DE_ENABLE);
+                au_writel(ac97_config, PSC_AC97CFG);
+                au_sync();
+                
+                ac97_config |= PSC_AC97CFG_TXSLOT_ENA(7);
+                ac97_config |= PSC_AC97CFG_TXSLOT_ENA(8);          
+                
+                au_writel(ac97_config, PSC_AC97CFG);
+                au_sync();
+                
+                ac97_config |= PSC_AC97CFG_DE_ENABLE;
+                au_writel(ac97_config, PSC_AC97CFG);
+                au_sync();
+                
+                /* Wait for Device ready.
+                 */
+                do {
+                        stat = readl(PSC_AC97STAT);
+                        au_sync();
+                } while ((stat & PSC_AC97STAT_DR) == 0);                
+        }
+        
+}
+#endif // I3_PATCH
+
 static void
 stop_dac(struct au1550_state *s)
 {
@@ -682,7 +811,7 @@
 	if (!db->rawbuf) {
 		db->ready = db->mapped = 0;
 		db->buforder = 5;	/* 32 * PAGE_SIZE */
-		db->rawbuf = kmalloc((PAGE_SIZE << db->buforder), GFP_KERNEL);
+		db->rawbuf = kmalloc((PAGE_SIZE << db->buforder), GFP_KERNEL); // 128 kB
 		if (!db->rawbuf)
 			return -ENOMEM;
 	}
@@ -760,6 +889,89 @@
 	return prog_dmabuf(s, &s->dma_dac);
 }
 
+#ifdef I3_PATCH
+// Interrupt routine when we are running a dma from rx to tx fifo
+static void
+adc2dac_dma_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+{
+	struct au1550_state *s = (struct au1550_state *) dev_id;
+	struct dmabuf  *db = &s->dma_adc;
+        int n;
+
+        // Make sure that we keep the descriptor ring full since
+        // it seems like we are loosing interrupts from the ddma.
+        for (n = 0; n < NUM_DBDMA_DESCRIPTORS; n++)
+                if (au1xxx_dbdma_put_dscr2(db->dmanr, DMA_RXTX_LOOP_TRANSFER_SIZE) == 0)
+                        break;
+
+}
+
+// Start a dma transfers from rx to tx fifo.
+// Use stop_adc() to stop.
+static void
+start_dma_rxtx_loop(struct au1550_state *s)
+{
+	struct dmabuf  *db = &s->dma_adc;
+	int	i;
+
+	if (!db->stopped)
+		return;
+
+
+	/* Put two buffers on the ring to get things started.
+	*/
+	for (i = 0; i < 2; i++)
+                au1xxx_dbdma_put_dscr2(db->dmanr, DMA_RXTX_LOOP_TRANSFER_SIZE);
+        
+        // Clear RX/TX fifo
+	au_writel(PSC_AC97PCR_RC, PSC_AC97PCR);
+	au_sync();
+	au_writel(PSC_AC97PCR_RS, PSC_AC97PCR);
+	au_sync();
+	au_writel(PSC_AC97PCR_TC, PSC_AC97PCR);
+	au_sync();
+	au_writel(PSC_AC97PCR_TS, PSC_AC97PCR);
+	au_sync();
+
+        // Start dma
+	au1xxx_dbdma_start(db->dmanr);
+
+	db->stopped = 0;
+}
+
+
+// Allocate dma resources for rx to tx transfer
+static void
+setup_dma_rxtx_loop(struct au1550_state *s)
+{
+        // Free current dma configuration
+        if (s->dma_adc.allocated)
+                au1xxx_dbdma_chan_free(s->dma_adc.dmanr);
+        if (s->dma_dac.allocated)
+                au1xxx_dbdma_chan_free(s->dma_dac.dmanr);
+        s->dma_dac.allocated = s->dma_adc.allocated = 0;
+
+        // Setup adc fifo to dac fifo dma
+	if ((s->dma_adc.dmanr = au1xxx_dbdma_chan_alloc(DBDMA_AC97_RX_CHAN,
+	    DBDMA_AC97_TX_CHAN, adc2dac_dma_interrupt, (void *)s)) == 0) {
+		err("Can't get ADC DMA for adc2dac");
+		goto err_dma;
+	}
+        s->dma_adc.allocated = 1;
+	au1xxx_dbdma_set_devwidth(s->dma_adc.dmanr, 16);
+
+	if (au1xxx_dbdma_ring_alloc(s->dma_adc.dmanr,
+					NUM_DBDMA_DESCRIPTORS) == 0) {
+		err("Can't get ADC DMA descriptors");
+		goto err_dma;
+	}
+
+	//info("DAC: DMA%d, ADC: DMA%d", DBDMA_AC97_TX_CHAN, DBDMA_AC97_RX_CHAN);        
+
+err_dma:
+        return;
+}
+#endif // I3_PATCH
 
 /* hold spinlock for the following */
 static void
@@ -779,8 +991,9 @@
 	   completed.
 	*/
 	db->dma_qcount--;
+	db->count -= db->fragsize;
 
-	if (db->count >= db->fragsize) {
+	if (db->count >= (db->dma_qcount + 1) * db->fragsize) {
 		if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut,
 							db->fragsize) == 0) {
 			err("qcount < 2 and no ring room1!");
@@ -788,7 +1001,6 @@
 		db->nextOut += db->fragsize;
 		if (db->nextOut >= db->rawbuf + db->dmasize)
 			db->nextOut -= db->dmasize;
-		db->count -= db->fragsize;
 		db->total_bytes += db->dma_fragsize;
 		db->dma_qcount++;
 	}
@@ -1227,7 +1439,7 @@
 		 * on the dma queue.  If the queue count reaches zero,
 		 * we know the dma has stopped.
 		 */
-		while ((db->dma_qcount < 2) && (db->count >= db->fragsize)) {
+		while ((db->dma_qcount < 2) && (db->count >= (db->dma_qcount + 1) * db->fragsize)) {
 			if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut,
 							db->fragsize) == 0) {
 				err("qcount < 2 and no ring room!0");
@@ -1236,8 +1448,12 @@
 			if (db->nextOut >= db->rawbuf + db->dmasize)
 				db->nextOut -= db->dmasize;
 			db->total_bytes += db->dma_fragsize;
-			if (db->dma_qcount == 0)
-				start_dac(s);
+			if (db->dma_qcount == 0) {
+                                // Do not start dac if user explicitly has disabled output
+                                // with SNDCTL_DSP_SETTRIGGER
+                                if (!s->output_disabled)
+                                        start_dac(s);
+                        }
 			db->dma_qcount++;
 		}
 		spin_unlock_irqrestore(&s->lock, flags);
@@ -1436,6 +1652,7 @@
 			stop_dac(s);
 			synchronize_irq();
 			s->dma_dac.count = s->dma_dac.total_bytes = 0;
+                        s->dma_dac.dma_qcount = 0;
 			s->dma_dac.nextIn = s->dma_dac.nextOut =
 				s->dma_dac.rawbuf;
 		}
@@ -1595,6 +1812,19 @@
 				stop_dac(s);
 				if (val == AFMT_S16_LE)
 					s->dma_dac.sample_size = 16;
+
+#ifdef I3_PATCH
+                                // i3 patch  AC3
+                                else  if (val == AFMT_AC3) {
+                                        s->dma_dac.sample_size = 16;
+                                        s->dma_dac.num_channels = 2;
+                                        set_dac_rate(s, 48*1000);
+                                        stop_dac(s);
+                                        stop_adc(s);
+                                        // Setup spdif with ac97 timeslot selected for AC3.
+                                        setup_spdif(s, SPDIF_AC3); 
+                                }
+#endif
 				else {
 					val = AFMT_U8;
 					s->dma_dac.sample_size = 8;
@@ -1635,6 +1865,7 @@
 				stop_adc(s);
 		}
 		if (file->f_mode & FMODE_WRITE) {
+                        s->output_disabled = ((val & PCM_ENABLE_OUTPUT) == 0);
 			if (val & PCM_ENABLE_OUTPUT)
 				start_dac(s);
 			else
@@ -1816,6 +2047,12 @@
 			return put_user(s->dma_adc.sample_size, (int *)arg);
 		else
 			return put_user(s->dma_dac.sample_size, (int *)arg);
+#ifdef I3_PATCH
+        case SNDCTL_DSP_RXTX_LOOP:
+                setup_dma_rxtx_loop(s);
+                start_dma_rxtx_loop(s);
+                return 0;
+#endif
 
 	case SOUND_PCM_WRITE_FILTER:
 	case SNDCTL_DSP_SETSYNCRO:
@@ -1826,6 +2063,67 @@
 	return mixdev_ioctl(s->codec, cmd, arg);
 }
 
+#ifdef I3_PATCH
+// i3 patch
+static void setup_dma(struct au1550_state *s)
+{
+        // Free DMA channels if already allocated
+        if (s->dma_adc.allocated)
+                au1xxx_dbdma_chan_free(s->dma_adc.dmanr);
+        if (s->dma_dac.allocated)
+                au1xxx_dbdma_chan_free(s->dma_dac.dmanr);
+        s->dma_adc.allocated= s->dma_dac.allocated = 0;
+
+	/* Allocate the DMA Channels
+	*/
+	if ((s->dma_dac.dmanr = au1xxx_dbdma_chan_alloc(DBDMA_MEM_CHAN,
+	    DBDMA_AC97_TX_CHAN, dac_dma_interrupt, (void *)s)) == 0) {
+		err("Can't get DAC DMA");
+		goto err_dma1;
+	}
+	au1xxx_dbdma_set_devwidth(s->dma_dac.dmanr, 16);
+
+	// i3 patch to remove half-word swapping made by the DDMA
+	{
+	  chan_tab_t        *ctp;
+	  dbdev_tab_t       *stp;
+	  ctp = *((chan_tab_t **)(s->dma_dac.dmanr));
+	  stp = ctp->chan_src;
+	  stp->dev_devwidth = 16;
+	}
+	// end i3 patch
+
+	if (au1xxx_dbdma_ring_alloc(s->dma_dac.dmanr,
+					NUM_DBDMA_DESCRIPTORS) == 0) {
+		err("Can't get DAC DMA descriptors");
+		goto err_dma1;
+	}
+
+	if ((s->dma_adc.dmanr = au1xxx_dbdma_chan_alloc(DBDMA_AC97_RX_CHAN,
+	    DBDMA_MEM_CHAN, adc_dma_interrupt, (void *)s)) == 0) {
+		err("Can't get ADC DMA");
+		goto err_dma2;
+	}
+	au1xxx_dbdma_set_devwidth(s->dma_adc.dmanr, 16);
+	if (au1xxx_dbdma_ring_alloc(s->dma_adc.dmanr,
+					NUM_DBDMA_DESCRIPTORS) == 0) {
+		err("Can't get ADC DMA descriptors");
+		goto err_dma2;
+	}
+
+        s->dma_adc.allocated = s->dma_dac.allocated = 1;
+
+	//info("DAC: DMA%d, ADC: DMA%d", DBDMA_AC97_TX_CHAN, DBDMA_AC97_RX_CHAN);
+
+        return;
+
+err_dma1:
+	au1xxx_dbdma_chan_free(s->dma_adc.dmanr);
+ err_dma2:
+	au1xxx_dbdma_chan_free(s->dma_dac.dmanr);
+
+}
+#endif // I3_PATCH
 
 static int
 au1550_open(struct inode *inode, struct file *file)
@@ -1861,6 +2159,12 @@
 		down(&s->open_sem);
 	}
 
+#ifdef I3_PATCH
+        // i3 patch
+        setup_spdif(s, SPDIF_PCM);
+        setup_dma(s);
+        s->output_disabled = 0;
+#endif
 	if (file->f_mode & FMODE_READ) {
 		stop_adc(s);
 		s->dma_adc.ossfragshift = s->dma_adc.ossmaxfrags =
@@ -1985,6 +2289,19 @@
 		goto err_dma1;
 	}
 	au1xxx_dbdma_set_devwidth(s->dma_dac.dmanr, 16);
+
+#ifdef I3_PATCH
+	// i3 patch to fix bug with half-word swapping made by the DDMA (not really noticed when
+        // playing PCM but fatal when sendinf AC3 on spdif)
+	{
+	  chan_tab_t        *ctp;
+	  dbdev_tab_t       *stp;
+	  ctp = *((chan_tab_t **)(s->dma_dac.dmanr));
+	  stp = ctp->chan_src;
+	  stp->dev_devwidth = 16;
+	}
+	// end i3 patch
+#endif // I3_PATCH
 	if (au1xxx_dbdma_ring_alloc(s->dma_dac.dmanr,
 					NUM_DBDMA_DESCRIPTORS) == 0) {
 		err("Can't get DAC DMA descriptors");
@@ -2003,7 +2320,7 @@
 		goto err_dma2;
 	}
 
-	info("DAC: DMA%d, ADC: DMA%d", DBDMA_AC97_TX_CHAN, DBDMA_AC97_RX_CHAN);
+	//info("DAC: DMA%d, ADC: DMA%d", DBDMA_AC97_TX_CHAN, DBDMA_AC97_RX_CHAN);
 
 	/* register devices */
 
@@ -2119,6 +2436,11 @@
 					     ac97_read_proc, &s->codec);
 #endif
 
+#ifdef I3_PATCH
+        s->dma_adc.allocated = s->dma_dac.allocated = 1;
+        setup_spdif(s, SPDIF_PCM);	
+#endif // I3_PATCH
+
 	set_xmit_slots(1);
 	set_recv_slots(1);
 
@@ -2151,8 +2473,21 @@
 		remove_proc_entry(AU1000_MODULE_NAME, NULL);
 #endif /* AU1000_DEBUG */
 	synchronize_irq();
+#ifdef I3_PATCH
+        if (s->dma_adc.allocated) 			// i3 patch
+        {
+#endif
 	au1xxx_dbdma_chan_free(s->dma_adc.dmanr);
+#ifdef I3_PATCH
+        }
+        if (s->dma_dac.allocated) 			// i3 patch
+        {
+#endif
 	au1xxx_dbdma_chan_free(s->dma_dac.dmanr);
+#ifdef I3_PATCH
+        }
+        s->dma_adc.allocated = s->dma_dac.allocated = 0;// i3 patch
+#endif
 	release_region(PHYSADDR(AC97_PSC_SEL), 0x30);
 	unregister_sound_dsp(s->dev_audio);
 	unregister_sound_mixer(s->codec->dev_mixer);
diff -x asm -Naur linux-2.4.30-orig/fs/Config.in linux-2.4.30/fs/Config.in
--- linux-2.4.30-orig/fs/Config.in	2005-05-12 18:01:30.000000000 +0200
+++ linux-2.4.30/fs/Config.in	2006-12-11 18:18:37.000000000 +0100
@@ -49,8 +49,34 @@
 dep_tristate 'Journalling Flash File System v2 (JFFS2) support' CONFIG_JFFS2_FS $CONFIG_MTD
 if [ "$CONFIG_JFFS2_FS" = "y" -o "$CONFIG_JFFS2_FS" = "m" ] ; then
    int 'JFFS2 debugging verbosity (0 = quiet, 2 = noisy)' CONFIG_JFFS2_FS_DEBUG 0
-   bool 'JFFS2 support for NAND chips' CONFIG_JFFS2_FS_NAND
+   bool 'JFFS2 write-buffering support' CONFIG_JFFS2_FS_WRITEBUFFER
+   bool 'JFFS2 ZLIB compression support (recommended)' CONFIG_JFFS2_ZLIB
+   bool 'JFFS2 RTIME compression support (recommended)' CONFIG_JFFS2_RTIME
+   bool 'JFFS2 RUBIN compression support' CONFIG_JFFS2_RUBIN
+   bool 'JFFS2 LZO compression support' CONFIG_JFFS2_LZO
+   bool 'JFFS2 LZARI compression support' CONFIG_JFFS2_LZARI
+   choice 'JFFS2 default compression mode' \
+        "none                                   CONFIG_JFFS2_CMODE_NONE \
+         priority                               CONFIG_JFFS2_CMODE_PRIORITY \
+         size                                   CONFIG_JFFS2_CMODE_SIZE" priority
+
+   bool 'JFFS2 proc interface support' CONFIG_JFFS2_PROC
+fi
+
+# Yaffs
+tristate 'Yet Another Flash Filing System(YAFFS) file system support' CONFIG_YAFFS_FS
+if [ "$CONFIG_YAFFS_FS" = "y" -o "$CONFIG_YAFFS_FS" = "m" ] ; then
+   bool 'NAND mtd support' CONFIG_YAFFS_MTD_ENABLED y
+   bool 'yaffsram file system support' CONFIG_YAFFS_RAM_ENABLED n
+   bool 'Old mtd support' CONFIG_YAFFS_USE_OLD_MTD n
+   bool 'Use ECC functions of the generic MTD-NAND driver' CONFIG_YAFFS_USE_NANDECC y
+   bool 'Use the same ecc byte order as Steven Hills nand_ecc.c' CONFIG_YAFFS_ECC_WRONG_ORDER n
+   bool 'Use Linux file caching layer' CONFIG_YAFFS_USE_GENERIC_RW y
+   bool 'Use object header size' CONFIG_YAFFS_USE_HEADER_FILE_SIZE n
+   bool 'Turn off debug chunk erase check' CONFIG_YAFFS_DISABLE_CHUNK_ERASED_CHECK n
+   bool 'Cache short names in RAM' CONFIG_YAFFS_SHORT_NAMES_IN_RAM y
 fi
+
 tristate 'Compressed ROM file system support' CONFIG_CRAMFS
 bool 'Virtual memory file system support (former shm fs)' CONFIG_TMPFS
 define_bool CONFIG_RAMFS y
diff -x asm -Naur linux-2.4.30-orig/fs/Makefile linux-2.4.30/fs/Makefile
--- linux-2.4.30-orig/fs/Makefile	2005-05-12 17:57:35.000000000 +0200
+++ linux-2.4.30/fs/Makefile	2006-12-11 18:18:37.000000000 +0100
@@ -54,6 +54,7 @@
 subdir-$(CONFIG_EFS_FS)		+= efs
 subdir-$(CONFIG_JFFS_FS)	+= jffs
 subdir-$(CONFIG_JFFS2_FS)	+= jffs2
+subdir-$(CONFIG_YAFFS_FS)	+= yaffs
 subdir-$(CONFIG_AFFS_FS)	+= affs
 subdir-$(CONFIG_ROMFS_FS)	+= romfs
 subdir-$(CONFIG_QNX4FS_FS)	+= qnx4
diff -x asm -Naur linux-2.4.30-orig/fs/fcntl.c linux-2.4.30/fs/fcntl.c
--- linux-2.4.30-orig/fs/fcntl.c	2005-05-12 17:57:35.000000000 +0200
+++ linux-2.4.30/fs/fcntl.c	2006-12-11 18:18:37.000000000 +0100
@@ -200,7 +200,7 @@
 	return ret;
 }
 
-#define SETFL_MASK (O_APPEND | O_NONBLOCK | O_NDELAY | FASYNC | O_DIRECT)
+#define SETFL_MASK (O_APPEND | O_NONBLOCK | O_NDELAY | FASYNC | O_DIRECT | O_STREAMING)
 
 static int setfl(int fd, struct file * filp, unsigned long arg)
 {
diff -x asm -Naur linux-2.4.30-orig/fs/jffs2/Makefile linux-2.4.30/fs/jffs2/Makefile
--- linux-2.4.30-orig/fs/jffs2/Makefile	2005-05-12 18:01:30.000000000 +0200
+++ linux-2.4.30/fs/jffs2/Makefile	2006-12-11 18:18:37.000000000 +0100
@@ -1,40 +1,43 @@
 #
-# Makefile for the linux Journalling Flash FileSystem (JFFS) routines.
+# fs/jffs2/Makefile.24
 #
-# $Id: Makefile.common,v 1.1 2003/05/27 09:34:41 dwmw2 Exp $
-#
-# Note! Dependencies are done automagically by 'make dep', which also
-# removes any old dependencies. DON'T put your own dependencies here
-# unless it's something special (ie not a .c file).
-#
-# Note 2! The CFLAGS definitions are now in the main makefile...
+# $Id: Makefile,v 1.2 2005/09/28 14:19:39 lel Exp $
 
+ifdef OUT_OF_TREE_BUILD
+include $(mtd)/defconfig
 
-obj-$(CONFIG_JFFS2_FS) := jffs2.o
+# This must be first in the include path, so it goes in $(CC) rather
+# then $(EXTRA_CFLAGS)
 
-COMPR_OBJS	:= compr.o compr_rubin.o compr_rtime.o compr_zlib.o
-JFFS2_OBJS	:= dir.o file.o ioctl.o nodelist.o malloc.o \
-	read.o nodemgmt.o readinode.o write.o scan.o gc.o \
-	symlink.o build.o erase.o background.o fs.o writev.o
+CC += -I$(mtd)/../../include
+EXTRA_CFLAGS := -g -Werror
 
-BELOW25		:= $(shell echo $(PATCHLEVEL) | sed s/[1234]/y/)
+ifndef CONFIG_MTD
+EXTRA_CFLAGS += -DMTD_OUT_OF_TREE
+endif
 
-ifeq ($(BELOW25),y)
-LINUX_OBJS	:= super-v24.o crc32.o rbtree.o
-else
-LINUX_OBJS	:= super.o
+ifdef NONAND
+EXTRA_CFLAGS += -DNONAND
+endif
 endif
 
-NAND_OBJS-$(CONFIG_JFFS2_FS_NAND)	:= wbuf.o
+obj-$(CONFIG_JFFS2_FS) += jffs2.o
 
-jffs2-objs := $(COMPR_OBJS) $(JFFS2_OBJS) $(VERS_OBJS) $(NAND_OBJS-y) \
-	$(LINUX_OBJS)
+JFFS2_OBJS := compr.o dir.o file.o ioctl.o nodelist.o malloc.o
+JFFS2_OBJS += read.o nodemgmt.o readinode.o write.o scan.o gc.o
+JFFS2_OBJS += symlink-v24.o build.o erase.o background.o fs.o writev.o
 
+#LINUX_OBJS += super-v24.o crc32.o rbtree.o
+LINUX_OBJS += super-v24.o crc32.o
 
-# 2.4 build compatibility
-ifeq ($(BELOW25),y)
-obj-y := $(jffs2-objs)
+WBUF_OBJS-$(CONFIG_JFFS2_FS_WRITEBUFFER) += wbuf.o
+
+COMPR_OBJS-$(CONFIG_JFFS2_RUBIN)  += compr_rubin.o
+COMPR_OBJS-$(CONFIG_JFFS2_RTIME)  += compr_rtime.o
+COMPR_OBJS-$(CONFIG_JFFS2_ZLIB)   += compr_zlib.o
+
+obj-y := $(COMPR_OBJS-y) $(JFFS2_OBJS) $(LINUX_OBJS) $(WBUF_OBJS-y)
 O_TARGET := jffs2.o
+
 include $(TOPDIR)/Rules.make
-endif
 
diff -x asm -Naur linux-2.4.30-orig/fs/jffs2/Makefile.common linux-2.4.30/fs/jffs2/Makefile.common
--- linux-2.4.30-orig/fs/jffs2/Makefile.common	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30/fs/jffs2/Makefile.common	2006-12-11 18:18:37.000000000 +0100
@@ -0,0 +1,17 @@
+#
+# Makefile for the Linux Journalling Flash File System v2 (JFFS2)
+#
+# $Id: Makefile.common,v 1.2 2005/09/28 14:19:39 lel Exp $
+#
+
+obj-$(CONFIG_JFFS2_FS) += jffs2.o
+
+jffs2-y	:= compr.o dir.o file.o ioctl.o nodelist.o malloc.o
+jffs2-y	+= read.o nodemgmt.o readinode.o write.o scan.o gc.o
+jffs2-y	+= symlink.o build.o erase.o background.o fs.o writev.o
+jffs2-y	+= super.o
+
+jffs2-$(CONFIG_JFFS2_FS_WRITEBUFFER)	+= wbuf.o
+jffs2-$(CONFIG_JFFS2_RUBIN)	+= compr_rubin.o
+jffs2-$(CONFIG_JFFS2_RTIME)	+= compr_rtime.o
+jffs2-$(CONFIG_JFFS2_ZLIB)	+= compr_zlib.o
diff -x asm -Naur linux-2.4.30-orig/fs/jffs2/TODO linux-2.4.30/fs/jffs2/TODO
--- linux-2.4.30-orig/fs/jffs2/TODO	2005-05-12 17:57:37.000000000 +0200
+++ linux-2.4.30/fs/jffs2/TODO	2006-12-11 18:18:37.000000000 +0100
@@ -1,4 +1,4 @@
-$Id: TODO,v 1.3 2001/03/01 23:26:48 dwmw2 Exp $
+$Id: TODO,v 1.2 2005/09/28 14:19:39 lel Exp $
 
  - disable compression in commit_write()? Or at least optimise the 'always write
 	whole page' bit.
diff -x asm -Naur linux-2.4.30-orig/fs/jffs2/background.c linux-2.4.30/fs/jffs2/background.c
--- linux-2.4.30-orig/fs/jffs2/background.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/fs/jffs2/background.c	2006-12-11 18:18:37.000000000 +0100
@@ -3,22 +3,18 @@
  *
  * Copyright (C) 2001-2003 Red Hat, Inc.
  *
- * Created by David Woodhouse <dwmw2@redhat.com>
+ * Created by David Woodhouse <dwmw2@infradead.org>
  *
  * For licensing information, see the file 'LICENCE' in this directory.
  *
- * $Id: background.c,v 1.48 2004/02/23 17:17:23 dwmw2 Exp $
+ * $Id: background.c,v 1.2 2005/09/28 14:19:39 lel Exp $
  *
  */
 
-#define __KERNEL_SYSCALLS__
-
 #include <linux/kernel.h>
 #include <linux/jffs2.h>
 #include <linux/mtd/mtd.h>
 #include <linux/completion.h>
-#include <linux/sched.h>
-#include <linux/unistd.h>
 #include <linux/suspend.h>
 #include "nodelist.h"
 
